

public class Link implements TrafficConstants
{
   private Node fromNode;
   private Node toNode;
   private int length;//# of sites on the link except Nodes
   private int direct;
   private Vehicle[] site;
	private int passby;
   
   public Link(Node fn, Node tn,int d,int l)
   {

      fromNode = fn;
      toNode = tn;
  
      direct = d;
      length = l;

		passby = 0;
      
      this.site= new Vehicle[this.length];
      for(int i=0; i<this.length; i++)
         site[i] = null;
           
      /*         
      //to determinate the direction of the link, but not true for BC!

      if(fromNode.getx() == toNode.getx())
         if(fromNode.gety() < toNode.gety()){
            this.direct = SOUTH;
         }
          else
            this.direct = NORTH;
      else if(fromNode.getx() < toNode.getx()){
         this.direct = EAST;
      }
      else
         this.direct = WEST;
      */
         
   }
      
   public Node getFromNode()
   {
      return this.fromNode;
   }
   
   public Node getToNode()
   {
      return this.toNode;
   }
   
   public int getDirect()
   {
      return this.direct;
   }
   
   public int getLength()
   {
      return this.length;
   }
   
   public Vehicle getSite(int i)
   {
      return this.site[i];
   }

   public void setSite(Vehicle car, int i)
   {
      this.site[i] = car;
		if(this.site[i] != null)
     		this.site[i].resetWaitTime();
   }
      
   public void updateLink()
   {  
      Vehicle car;
		int[] moves = new int[length];
		for(int i=0;i<length;i++)
		    moves[i] = 0;

		passby = 0;
      
      //FOR UPDATE , check the first site
      //leaving from site[0],but update link later
      if(this.site[0]!=null){
		    site[0].increaseWaitTime();

          if(toNode.getStatus() == null && toNode.getForbid() == false){  
				  moves[0] = 1;
              site[0].setVelocity(1);
			 }              
          else 
              site[0].setVelocity(0); 
      }
      
      for (int i=1; i < this.length; i++)
         if (site[i] != null){
			    site[i].increaseWaitTime();
				 if(site[i-1] == null){
                 site[i].setVelocity(1);
					  moves[i] = 1;
				 }
             else
                 site[i].setVelocity(0);
         }
        
      if((car=this.fromNode.getStatus())!= null)
		   //car at node must stay no less than two seconds before it leaves
         if(this.site[length-1] == null && car.getWaitTime() > 1)
               if(car.getDirection()==this.direct ||
				           car.getDirection()==(this.direct-2))
               {                       
                   car.setDirection(this.direct);//correct direction of the car
                   car.setVelocity(1);
						 setSite(car,length-1);//moving into link
                   //this.site[length-1] = car; 
						 //this.site[length-1].resetWaitTime();
                   this.fromNode.setForbid(true);
                   this.fromNode.setStatus(null);//leaving from fromNode 
                } 
            
      //update
      for (int i=length-1; i>=1; i--)
         if (site[i]!=null)
             if(moves[i] == 1){
                 //move
					  setSite(site[i],i-1);
                 site[i] = null;
					  passby = 1;
             }       
            
      if(moves[0]==1){
         //???update Node now, to avoid collisions
         //?should set v=1 when move in, set v=0 when turning
         this.toNode.setStatus(this.site[0]);
         this.site[0]=null;
      }
           
   }//end of method

	public int getPassby() { return passby; }
   
}
