/*
	.having MaxWaitTime
	if the waiting time of the car on the cross exceeds MaxWaitTime,
	make turn again if random()>pturn
*/
import java.lang.Math;
     
public class Node implements TrafficConstants{

  //Nodes are the sites connecting Links, ie. intersections
   private int x;
   private int y;
   private Vehicle cross;//refer to a vehicle object
   private boolean forbid; //to avoid collision at intersections
	                        //forbid more than one car moving into this node
   private float pturn;
   
   public Node(int x1,int y1, float pturn)
   {
      this.x = x1;
      this.y = y1;
      this.cross = null;
      this.forbid = false;
      this.pturn = pturn;
   }
   
   public int getx(){
      return this.x;
   }
   public int gety() {
      return this.y;
   }
   
   public Vehicle getStatus()
   {
      return cross;
   }
   public void setStatus(Vehicle car)
   {
      this.cross = car;
		if(this.cross != null){
	       setForbid(true);
			 cross.resetWaitTime();
		}
   }

   public void setForbid(boolean f)
   {
        this.forbid = f;
   }

   public boolean getForbid()
   {
      return this.forbid;
   }
   
   public void updateNode()
   {
      //when cross==null,forbid==true, car has left to some link, but cars from other links
      //can not move in this cross at same time step (last time step)
      //next time step, when I update nodes, set forbid=false, permit to move in again
      if(this.cross == null && this.forbid==true)
          this.forbid = false;


      if (this.cross != null){
		    cross.increaseWaitTime();//increase for all cars staying at nodes

	       if(this.cross.getWaitTime() == 1)//the car just move in last time step
          { 
		        //cross.setTurnMade(true);
              cross.setVelocity(0);
              if((float)Math.random() <= pturn)              
               //just set temp direction:
                //all North and South set to East,
               //all East and West set to North  
           	     turnDecide();          

          }//end of the inner 'if'
            
			 else if(((cross.getWaitTime()/MaxWaitTime)*MaxWaitTime) 
			 			== cross.getWaitTime())
			 	 turnDecide();  

			 //else (don't make turn, forbid=true, stay)	
      }//end of the outter 'if' (if there's a car in the node)        
   }//end of updateNode method

	private void turnDecide(){
		switch (cross.getDirection()){
	      case NORTH:
         {
   	   	cross.setDirection(EAST);
            break;
         }
         case SOUTH:
         {
            cross.setDirection(EAST);
            break;
         }
         case EAST:
         {
      	   cross.setDirection(NORTH);
            break;
         }
         case WEST:
         {
            cross.setDirection(NORTH);
            break;
         }
       }//end of switch
	}
   
}
