import java.lang.Math;

public class Traffic implements TrafficConstants{

    private Node[][] myNode;
    private Link[][] myLink;    
    private int carNo, linkNo;
    private int[] ln4;

    public int[][] forDraw;
	 private int passby;
      
    public Traffic(float density,float pturn)
    {
        carNo = 0;
        linkNo = 0;
        ln4 = new int[4];
        myNode = new Node[5][5];
        myLink = new Link[4][20];
        Vehicle tempCar;
		  passby = 0;
        
        int c=0, d=0;
        
        int x0 = 200;
        int y0 = 160;
        for(int i=0;i<5; i++)
           for(int j=0; j<5; j++)
           {  
	            myNode[i][j] = new Node(x0+j*200, y0+i*160,pturn);
           
            	if((float)Math.random()<= density){
           	 	   d++;//chose direction arbitrarily
            	   c++;
             	   if(d>4) d=d-4;
             	   if(c>8) c=c-8;
	               tempCar = new Vehicle(0,d,c);
   	            myNode[i][j].setStatus(tempCar);
      	         carNo++;
               } 
              
           }  


        
        d = EAST;        
        int col = 0;
        for(int i=0; i<5; i=i+2)
           for(int j=0; j<5; j++)
           {
		         if(j!=4)
                  myLink[d-1][col]= new Link(myNode[i][j],myNode[i][j+1],d,9);
	            else 
   	            myLink[d-1][col]= new Link(myNode[i][j],myNode[i][0],d,9);
			
         	   for(int k=0; k < 9; k++)
            	   if((float)Math.random()<= density) {
               	   c++;  //c={1..8}
                  	if(c>8)
                     	c = c-8;
                     tempCar = new Vehicle(0,d,c);
                     myLink[d-1][col].setSite(tempCar,k);
                     carNo++;
                  }
            	col++;
           }//end of EAST
      ln4[d-1] = col;
      linkNo += col;
      
      d = WEST;
      col = 0;
      for(int i=1; i<5;i=i+2)
         for(int j=0;j<5;j++)
         {
            if(j != 4)
               myLink[d-1][col]= new Link(myNode[i][j+1],myNode[i][j],d,9);
            else
               myLink[d-1][col]= new Link(myNode[i][0],myNode[i][j],d,9);
            
            for(int k=0; k< 9; k++)
               if((float)Math.random()<= density) {
                    c++;
                    if (c>8) c-=8;
                    tempCar = new Vehicle(0,d,c);
                    myLink[d-1][col].setSite(tempCar,k);
                    carNo++;
               }
            col++;
         }//end of WEST
      ln4[d-1] = col;
      linkNo += col;
     
      d = SOUTH;
      col = 0;
      for(int j=0; j<5; j=j+2)
         for(int i=0;i<5;i++)
         {
            if(i != 4)
               myLink[d-1][col]= new Link(myNode[i][j],myNode[i+1][j],d,7);
            else
               myLink[d-1][col]= new Link(myNode[i][j],myNode[0][j],d,7);
            
            for(int k=0; k<myLink[d-1][col].getLength(); k++)
               if((float)Math.random()<= density) {
                    c++;
                    if (c>8) c-=8;
                    tempCar = new Vehicle(0,d,c);
                    myLink[d-1][col].setSite(tempCar,k);
                    carNo++;
               }
            col++;
         }//end of SOUTH
      ln4[d-1] = col;
      linkNo += col;
      
      d = NORTH;
      col = 0;
      for(int j=1; j<5; j=j+2)
         for(int i=0;i<5;i++)
         {
            if(i != 4)
               myLink[d-1][col]= new Link(myNode[i+1][j],myNode[i][j],d,7);
            else
               myLink[d-1][col]= new Link(myNode[0][j],myNode[i][j],d,7);
            
            for(int k=0; k<myLink[d-1][col].getLength(); k++)
               if((float)Math.random()<= density) {
                  c++;
                    if (c>8) c-=8;
                    tempCar = new Vehicle(0,d,c);
                    myLink[d-1][col].setSite(tempCar,k);
                    carNo++;
                 }
            col++;
         }//end of NORTH
      ln4[d-1] = col;
      linkNo += col;

      forDraw =new int[carNo][6];
   }
   
   public int getCarNo(){
       return carNo;
   }

   public int computeForDraw()
   {
      int i,j,k;
      int x0,y0;
      for(i=0;i< carNo; i++)
          for(j=0; j<6; j++)
            forDraw[i][j] =0;
     
      int n=0;
         
      Vehicle car0;
      for(i=0;i<5;i++)
         for(j=0;j<5;j++)
            if((car0 = myNode[i][j].getStatus() )!=null)
            {
               x0 = myNode[i][j].getx();
               y0 = myNode[i][j].gety();
               forDraw[n][4] = car0.getColor();
               forDraw[n][5] = car0.getVelocity();
               if(car0.getDirection()==NORTH || car0.getDirection() ==SOUTH)
               {
                  forDraw[n][0] = x0-carWid/2;
                  forDraw[n][1] = y0-carLen/2;
                  forDraw[n][2] = carWid;
                  forDraw[n][3] = carLen;
               }
               else
               {
                  forDraw[n][0] = x0-carLen/2;
                  forDraw[n][1] = y0-carWid/2;
                  forDraw[n][2] = carLen;
                  forDraw[n][3] = carWid;    
               }
               n++;
            }//end of getting param of car at myNode[][]    
      
      for(i=0;i<4;i++)
         for(j=0; j<ln4[i]; j++)
         {
              x0 = myLink[i][j].getFromNode().getx();
              y0 = myLink[i][j].getFromNode().gety();

              switch (myLink[i][j].getDirect())
              {
              case NORTH:{
                       x0 -= carWid/2;
                       y0 -= carLen/2;  //(x0,y0)is the upper left coner of the car at the fromNode

                       for(k=myLink[i][j].getLength()-1; k>=0; k--)
                       {
                          y0 -=siteLength;
                          if((car0=myLink[i][j].getSite(k)) !=null)
                          {
                             forDraw[n][4] = car0.getColor();
                             forDraw[n][5] = car0.getVelocity();
                             forDraw[n][0] = x0;
                             forDraw[n][1] = y0;
                             forDraw[n][2] = carWid;
                             forDraw[n][3] = carLen;
                             n++;
                          }
                       }
                       break;
                     }
                        
              case EAST:{
                       if(x0 >= 990) x0 -= 1000;  //x0=1040; fromNode at East end, BC used
                       x0 -= carLen/2;
                       y0 -= carWid/2; //(x0,y0)is the upper left coner of the car at the fromNode

                       for(k=myLink[i][j].getLength()-1; k>=0; k--)
                       {
                          x0 +=siteLength;
                          if((car0=myLink[i][j].getSite(k)) !=null)
                          {
                             forDraw[n][4] = car0.getColor();
                             forDraw[n][5] = car0.getVelocity();
                             forDraw[n][0] = x0;
                             forDraw[n][1] = y0;
                             forDraw[n][2] = carLen;
                             forDraw[n][3] = carWid;
                             n++;
                          }
                       }
                       break;
                     }              
              
                case SOUTH:{
                       if (y0 >= 790) y0 -= 800; // y0=840, fromNode at South end, BC used 
                       x0 -= carWid/2;
                       y0 -= carLen/2; //(x0,y0)is the upper left coner of the car at the fromNode

                       for(k=myLink[i][j].getLength()-1; k>=0; k--)
                       {
                          y0 +=siteLength;
                          if((car0=myLink[i][j].getSite(k)) !=null)
                          {
                             forDraw[n][4] = car0.getColor();
                             forDraw[n][5] = car0.getVelocity();
                             forDraw[n][0] = x0;
                             forDraw[n][1] = y0;
                             forDraw[n][2] = carWid;
                             forDraw[n][3] = carLen;
                             n++;
                          }
                       }
                       break;
                     }
                        
            case WEST:{
                       x0 -= carLen/2;
                       y0 -= carWid/2; //(x0,y0)is the upper left coner of the car at the fromNode

                       for(k=myLink[i][j].getLength()-1; k>=0; k--)
                       {
                          x0 -=siteLength;
                          if((car0=myLink[i][j].getSite(k)) != null)
                          {
                             forDraw[n][4] = car0.getColor();
                             forDraw[n][5] = car0.getVelocity();
                             forDraw[n][0] = x0;
                             forDraw[n][1] = y0;
                             forDraw[n][2] = carLen;
                             forDraw[n][3] = carWid;                              
                             n++;
                          }
                       }
                       break;
                     }  
            }//end of switch, getting the params of cars in myLink[i][j]

        }//end of for loop
        return n;
   }
 
   public int getDraw(int i, int j){
       return forDraw[i][j];
   }

   public void updateTraffic()
   {
		passby = 0;
      int i,j;
      for(i=0;i<5;i++)
         for(j=0;j<5;j++)
            myNode[i][j].updateNode();

	   for(i=0;i<4;i++)
         for(j=0; j<ln4[i]; j++){
            myLink[i][j].updateLink();
				passby += myLink[i][j].getPassby();
			}
   }

	public float getFlow(){
		float flow = (float)passby/(float)linkNo;
		return flow;
	}
   
}

